	title	d3d9xtext - Siekmanski 2004
	.586
	.XMM
	.model	flat,stdcall
	option	casemap:none   ; Case sensitive

include	..\..\include\windows.inc
include	..\..\include\kernel32.inc
include	..\..\include\user32.inc
include	..\..\include\winmm.inc
include	..\..\include\gdi32.inc
include	\masm32\include\comdlg32.inc

include	..\..\d3dx9includes\dx9macros.inc
include	..\..\d3dx9includes\d3dx9.inc

includelib	..\..\lib\kernel32.lib
includelib	..\..\lib\user32.lib
includelib	..\..\lib\winmm.lib
includelib	..\..\lib\gdi32.lib
includelib	\masm32\lib\comdlg32.lib

includelib	..\..\lib\advapi32.lib
includelib	..\..\lib\uuid.lib
includelib	..\..\lib\libci.lib
includelib	..\..\lib\msvcrt.lib

includelib	..\..\d3dx9libs\d3dx9.lib
includelib	..\..\d3dx9libs\d3d9.lib


SMILEY_ICON			equ	200
IDR_TXT3d			equ   201
IDI_MENU			equ   500
ID_FONT			equ	501
ID_EXIT			equ	502

.data
ClassName				db  "dx9Text3D",0
AppName				db  "dx9Text3D: Text in a 3D scene - Siekmanski",0

align	4
g_pD3D				LPDIRECT3D9			NULL	;// Used to create the D3DDevice
g_pD3DDevice			LPDIRECT3DDEVICE9		NULL ;// Our rendering device
g_pFont				LPD3DXFONT			NULL
g_pFont2				LPD3DXFONT			NULL
g_pD3DXSprite			LPD3DXSPRITE		NULL
g_pFontMesh		            LPD3DXMESH			NULL

d3dpp					D3DPRESENT_PARAMETERS<>
d3ddm					D3DDISPLAYMODE<>
d3dcaps				D3DCAPS9<>
d3dadapter				D3DADAPTER_IDENTIFIER9<>

vEyePt				D3DXVECTOR3	<0.0f, 0.0f,-15.0f>
vLookatPt				D3DXVECTOR3	<7.0f, 2.0f, 0.0f>
vUpVec				D3DXVECTOR3	<0.0f, 1.0f, 0.0f>

vecLightDirUnnormalized	      D3DXVECTOR3 <10.0f,-10.0f,10.0f>

d3d_timer				dd 0

Text3dW				dd 0

m_bMinimized			dd	FALSE
m_bMaximized			dd	FALSE

hInst					dd  0
hWnd					dd  0 
Heap					dd  0

Window_width			dd	640
Window_height			dd	480

Font_name				db LF_FACESIZE+1 dup (0)
Font_size				dd 0
Font_bold				dd 0
Font_italic			      dd 0

Vertex_types			db 36 dup (0)
.code

InitFont	proc
LOCAL		hdc:DWORD
LOCAL		hFont:DWORD
LOCAL		hFontOld:DWORD

	SAFE_RELEASE	g_pFont2		
	invoke	GetDC,NULL
	mov		hdc,eax
	invoke	GetDeviceCaps,hdc,LOGPIXELSY
	mov		ecx,Font_size
	mul 		ecx
	mov 		ecx,72
	xor 		edx,edx
	div 		ecx
	neg 		eax
	invoke	D3DXCreateFont,g_pD3DDevice,eax,0,Font_bold,0,Font_italic,DEFAULT_CHARSET,\
                         OUT_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH or FF_DONTCARE,\ 
                         addr Font_name,addr g_pFont2
	invoke	ReleaseDC,NULL,hdc



	invoke	CreateCompatibleDC,NULL
	mov		hdc,eax	
	invoke	GetDeviceCaps,hdc,LOGPIXELSY
	mov		ecx,12
	mul 		ecx
	mov 		ecx,72
	xor 		edx,edx
	div 		ecx
	neg 		eax
	invoke	CreateFont,eax,0,0,0,Font_bold,Font_italic,FALSE,FALSE,DEFAULT_CHARSET,\ 
				OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH or FF_DONTCARE,addr Font_name
	mov		hFont,eax
	invoke	SelectObject,hdc,hFont
	mov		hFontOld,eax

	SAFE_RELEASE	g_pFontMesh
	invoke	D3DXCreateText,g_pD3DDevice,hdc,TEXT_("This is calling D3DXCreateText"),\ 
				FLOAT_(0.001f),FLOAT_(0.4f),addr g_pFontMesh,NULL,NULL

	invoke	SelectObject,hdc,hFontOld
	invoke	DeleteObject,hFont
	invoke	DeleteDC,hdc
	ret
InitFont	endp

;//-----------------------------------------------------------------------------
;// Name: InitD3D
;// Desc: Initializes Direct3D
;//-----------------------------------------------------------------------------
InitD3D	proc hwnd:DWORD
LOCAL		rsrc:HRSRC
LOCAL		pvData:DWORD
LOCAL		cbData:DWORD

	invoke		Direct3DCreate9,D3D_SDK_VERSION
	if_FAILED
		return	E_FAIL
	.endif

	mov			g_pD3D,eax

	coinvoke	g_pD3D,IDirect3D9,GetAdapterIdentifier,D3DADAPTER_DEFAULT,0,addr d3dadapter
	if_FAILED
		return	E_FAIL
	.endif

	coinvoke	g_pD3D,IDirect3D9,GetAdapterDisplayMode,D3DADAPTER_DEFAULT,ADDR d3ddm
	if_FAILED
		return	E_FAIL
	.endif

	invoke		lstrcpy,addr Font_name,TEXT_("Arial")
	mov			Font_size,12
	mov			Font_bold,FW_NORMAL
	mov			Font_italic,FALSE

	;Load resource textfile
	invoke		FindResource,NULL,IDR_TXT3d,TEXT_("TEXT")
	mov			rsrc,eax
	invoke		SizeofResource,NULL,rsrc
	mov			cbData,eax
	invoke		LoadResource,NULL,rsrc
	invoke		LockResource,eax
	mov			pvData,eax
	mov			eax,cbData
	add			eax,2
	Alloc_mem	      Text3dW,eax

	push		esi
	push		edi
	mov			esi,pvData
	mov			edi,Text3dW
	mov		 	ecx,cbData
	cld
	rep 		      movsb
	xor 		      eax,eax
	stosw
	pop			edi
	pop			esi

	return		S_OK
InitD3D	endp

;//-----------------------------------------------------------------------------
;// Name: InitGeometry
;// Desc: Load the mesh and build the material and texture arrays
;//-----------------------------------------------------------------------------
InitGeometry 	proc hwnd:DWORD
LOCAL		matView:	D3DXMATRIXA16
LOCAL		matProj:	D3DXMATRIXA16
LOCAL		AspectRatio:DWORD
LOCAL		light:D3DLIGHT9
LOCAL		hdc:DWORD
LOCAL		Dev_type:DWORD

	invoke		RtlZeroMemory,addr d3dpp,sizeof d3dpp
	mov			d3dpp.Windowed,TRUE
	mov			d3dpp.SwapEffect,D3DSWAPEFFECT_DISCARD
	mov			eax,d3ddm.Format
	mov			d3dpp.BackBufferFormat,eax
	mov			d3dpp.EnableAutoDepthStencil,TRUE
	mov			d3dpp.AutoDepthStencilFormat,D3DFMT_D16
	mov			d3dpp.PresentationInterval,D3DPRESENT_INTERVAL_IMMEDIATE 
;	mov			d3dpp.PresentationInterval,D3DPRESENT_INTERVAL_DEFAULT
;	mov			d3dpp.PresentationInterval,D3DPRESENT_INTERVAL_ONE

	SAFE_RELEASE	g_pD3DDevice
	mov			Dev_type,D3DDEVTYPE_HAL
	invoke		lstrcpy,addr Vertex_types,TEXT_("HAL Pure hardware vertex processing")
	coinvoke	g_pD3D,IDirect3D9,CreateDevice,D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL,hwnd,\
							D3DCREATE_HARDWARE_VERTEXPROCESSING or D3DCREATE_PUREDEVICE,addr d3dpp,addr g_pD3DDevice
	if_FAILED
		invoke	lstrcpy,addr Vertex_types,TEXT_("HAL Hardware vertex processing")
		coinvoke	g_pD3D,IDirect3D9,CreateDevice,D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL,hwnd,\
                           	D3DCREATE_HARDWARE_VERTEXPROCESSING,addr d3dpp,addr g_pD3DDevice
		if_FAILED
			invoke	lstrcpy,addr Vertex_types,TEXT_("HAL Mixed vertex processing")
			coinvoke	g_pD3D,IDirect3D9,CreateDevice,D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL,hwnd,\
       	                    		D3DCREATE_MIXED_VERTEXPROCESSING,addr d3dpp,addr g_pD3DDevice
			if_FAILED
				invoke	lstrcpy,addr Vertex_types,TEXT_("HAL Software vertex processing")
				coinvoke	g_pD3D,IDirect3D9,CreateDevice,D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL,hwnd,\
       	                    			D3DCREATE_SOFTWARE_VERTEXPROCESSING,addr d3dpp,addr g_pD3DDevice
				if_FAILED
					mov			Dev_type,D3DDEVTYPE_REF
					invoke	lstrcpy,addr Vertex_types,TEXT_("REF Software vertex processing")
					coinvoke	g_pD3D,IDirect3D9,CreateDevice,D3DADAPTER_DEFAULT,D3DDEVTYPE_REF,hwnd,\
       	                    			D3DCREATE_SOFTWARE_VERTEXPROCESSING,addr d3dpp,addr g_pD3DDevice
					if_FAILED

						return	E_FAIL
					.endif
				.endif
			.endif
		.endif
	.endif

	coinvoke	g_pD3D,IDirect3D9,GetDeviceCaps,D3DADAPTER_DEFAULT,Dev_type,addr d3dcaps
	if_FAILED
		return	E_FAIL
	.endif

	SAFE_RELEASE	g_pD3DXSprite
	invoke	D3DXCreateSprite,g_pD3DDevice,addr g_pD3DXSprite

	coinvoke	g_pD3DDevice,IDirect3DDevice9,SetTextureStageState,0,D3DTSS_COLORARG1,D3DTA_TEXTURE
	coinvoke	g_pD3DDevice,IDirect3DDevice9,SetTextureStageState,0,D3DTSS_COLORARG2,D3DTA_DIFFUSE
	coinvoke	g_pD3DDevice,IDirect3DDevice9,SetTextureStageState,0,D3DTSS_COLOROP,D3DTOP_MODULATE
	coinvoke	g_pD3DDevice,IDirect3DDevice9,SetSamplerState,0,D3DSAMP_MINFILTER,D3DTEXF_LINEAR
	coinvoke	g_pD3DDevice,IDirect3DDevice9,SetSamplerState,0,D3DSAMP_MAGFILTER,D3DTEXF_LINEAR

	coinvoke	g_pD3DDevice,IDirect3DDevice9,SetRenderState,D3DRS_ZENABLE,TRUE
	coinvoke	g_pD3DDevice,IDirect3DDevice9,SetRenderState,D3DRS_DITHERENABLE,TRUE
	coinvoke	g_pD3DDevice,IDirect3DDevice9,SetRenderState,D3DRS_SPECULARENABLE,TRUE
	coinvoke	g_pD3DDevice,IDirect3DDevice9,SetRenderState,D3DRS_LIGHTING,TRUE
	coinvoke	g_pD3DDevice,IDirect3DDevice9,SetRenderState,D3DRS_AMBIENT,080808080h


	invoke	RtlZeroMemory,addr light,sizeof D3DLIGHT9
      mov 		light.dx_Type,D3DLIGHT_DIRECTIONAL
	mov		eax,FLOAT_(1.0f)
      mov 		light.Diffuse.r,eax
      mov 		light.Diffuse.g,eax
      mov 		light.Diffuse.b,eax
	lea		eax,light.Direction
	invoke	D3DXVec3Normalize,eax,addr vecLightDirUnnormalized
	mov		eax,FLOAT_(10.0f)
      mov 		light.Position.x,eax
	mov		eax,FLOAT_(-10.0f)
      mov 		light.Position.y,eax
	mov		eax,FLOAT_(10.0f)
      mov 		light.Position.z,eax
	mov		eax,FLOAT_(100.0f)
      mov 		light.Range,eax

	coinvoke	g_pD3DDevice,IDirect3DDevice9,SetLight,0, addr light
	coinvoke	g_pD3DDevice,IDirect3DDevice9,LightEnable,0,TRUE


	invoke	D3DXMatrixLookAtLH,addr matView,addr vEyePt,addr vLookatPt,addr vUpVec
	coinvoke	g_pD3DDevice,IDirect3DDevice9,SetTransform,D3DTS_VIEW,addr matView

	;Calculate aspectratio
	fld		d3dpp.BackBufferWidth
	fdiv		d3dpp.BackBufferHeight
	fstp		AspectRatio

	invoke	D3DXMatrixPerspectiveFovLH,addr matProj,FLOAT_(D3DX_PI_QUARTER),AspectRatio,\
										   FLOAT_(1.0f),FLOAT_(100.0f)

	coinvoke	g_pD3DDevice,IDirect3DDevice9,SetTransform,D3DTS_PROJECTION,addr matProj

	; make system font
	SAFE_RELEASE	g_pFont		
	invoke	GetDC,NULL
	mov		hdc,eax
	invoke	GetDeviceCaps,hdc,LOGPIXELSY
	mov		ecx,10			; calculate the font height
	mul 		ecx
	mov 		ecx,72
	xor 		edx,edx
	div 		ecx
	neg 		eax
	invoke	D3DXCreateFont,g_pD3DDevice,eax,0,FW_BOLD,0,FALSE,DEFAULT_CHARSET,\
                         OUT_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH or FF_DONTCARE,\ 
                         TEXT_("System"),addr g_pFont
	invoke	ReleaseDC,NULL,hdc

	invoke	InitFont	; make other font and 3dfont	

	return	S_OK
InitGeometry	endp

;//-----------------------------------------------------------------------------
;// Name: Cleanup
;// Desc: Releases all previously initialized objects
;//-----------------------------------------------------------------------------
Cleanup 	proc
	Delete_mem		Text3dW
	SAFE_RELEASE	g_pD3DXSprite
	SAFE_RELEASE	g_pFontMesh
	SAFE_RELEASE	g_pFont
	SAFE_RELEASE	g_pFont2
	SAFE_RELEASE	g_pD3DDevice
	SAFE_RELEASE	g_pD3D
	ret
Cleanup	endp

;//-----------------------------------------------------------------------------
;// Name: SetupMatrices
;// Desc: Sets up the world, view, and projection transform matrices.
;//-----------------------------------------------------------------------------
SetupMatrices 	proc
align 16	;keep matrices 16-byte aligned as preferred by P4 cpu's.
LOCAL	matWorld:	D3DXMATRIXA16
LOCAL	matRotation:D3DXMATRIXA16
LOCAL	x_angle:	DWORD

	invoke	timeGetTime
	mov		d3d_timer,eax

	fild		d3d_timer
	fdiv		FLOAT_(1000.0f)	;rotation speed
	fstp		x_angle

	invoke	D3DXMatrixRotationX,addr matWorld,x_angle
	invoke	D3DXMatrixRotationY,addr matRotation,FLOAT_(0.45f)
	invoke	D3DXMatrixMultiply,addr matWorld,addr matWorld,addr matRotation
	coinvoke	g_pD3DDevice,IDirect3DDevice9,SetTransform,D3DTS_WORLD,addr matWorld

	ret
SetupMatrices 	endp


FrameStats proc
LOCAL	rc:RECT
.data
fLastTime dd 0
dwFrames  dd 0
Stat_Str  db 32 dup (0)
.code
	inc		dwFrames
	mov		eax,d3d_timer
	sub		eax,fLastTime
	.if	eax > 1000
		sub	  eax,1000
 		invoke  wsprintf,addr Stat_Str,TEXT_("Fps: %d.%03d  (%d x %d)"),dwFrames,eax,d3dpp.BackBufferWidth,d3dpp.BackBufferHeight
		mov	  eax,d3d_timer
		mov	  fLastTime,eax
		mov 	 dwFrames,0
	.endif

	invoke	SetRect,addr rc,2,0,0,0
	coinvoke	g_pFont,ID3DXFont,DrawTextA,NULL,addr d3dadapter.Description,-1,addr rc,DT_NOCLIP,D3DCOLOR_XRGB(255,255,0)
	invoke	SetRect,addr rc,2,15,0,0
	coinvoke	g_pFont,ID3DXFont,DrawTextA,NULL,addr Stat_Str,-1,addr rc,DT_NOCLIP,D3DCOLOR_XRGB(255,255,0)
	invoke	SetRect,addr rc,2,15*2,0,0
	coinvoke	g_pFont,ID3DXFont,DrawTextA,NULL,addr Vertex_types,-1,addr rc,DT_NOCLIP,D3DCOLOR_XRGB(255,255,0)
	ret
FrameStats endp

;//-----------------------------------------------------------------------------
;// Name: RenderD3D
;// Desc: Draws the scene
;//-----------------------------------------------------------------------------
RenderD3d	proc
LOCAL	rc:RECT
LOCAL	mtrl:D3DMATERIAL9

	;// Clear the backbuffer and the zbuffer
	coinvoke	g_pD3DDevice,IDirect3DDevice9,Clear,0,NULL,D3DCLEAR_TARGET or D3DCLEAR_ZBUFFER,\
													D3DCOLOR_XRGB(0,0,0),FLOAT_(1.0f),0
	;// Begin the scene
	coinvoke	g_pD3DDevice,IDirect3DDevice9,BeginScene
   if_SUCCEEDED

		;// Setup the world, view, and projection matrices
		invoke	SetupMatrices

		;// Demonstration 1:
		;// Word wrapping and unicode text.  
		;// Note that not all fonts support dynamic font linking. 
		mov		eax,d3dpp.BackBufferWidth
		sub		eax,10
		mov		ecx,d3dpp.BackBufferHeight
		sub		ecx,10
		invoke	SetRect,addr rc,10,60,eax,ecx
		coinvoke	g_pFont,ID3DXFont,DrawTextW,NULL,Text3dW,-1,addr rc, DT_LEFT or DT_WORDBREAK or DT_EXPANDTABS,D3DCOLOR_XRGB(255,0,255)

		;// Demonstration 2:
		;// Draw a simple line using ID3DXFont::DrawText
		invoke	SetRect,addr rc,150,200,0,0
		coinvoke	g_pFont2,ID3DXFont,DrawTextA,NULL,TEXT_("This is a trival call to ID3DXFont_DrawTextA"),-1,addr rc,DT_NOCLIP,D3DCOLOR_XRGB(255,0,0)

		;// Demonstration 3:
		;// Allow multiple draw calls to sort by texture changes by ID3DXSprite
		;// When drawing 2D text use flags: D3DXSPRITE_ALPHABLEND or D3DXSPRITE_SORT_TEXTURE
		;// When drawing 3D text use flags: D3DXSPRITE_ALPHABLEND or D3DXSPRITE_SORT_BACKTOFRONT
		coinvoke	g_pD3DXSprite,ID3DXSprite,Begin,D3DXSPRITE_ALPHABLEND or D3DXSPRITE_SORT_TEXTURE
		mov		eax,d3dpp.BackBufferHeight
		sub		eax,15*6
		invoke	SetRect,addr rc, 10,eax,0,0
		coinvoke	g_pFont,ID3DXFont,DrawTextA,g_pD3DXSprite,TEXT_("These multiple calls to ID3DXFont_DrawTextA using the same ID3DXSprite."),-1,addr rc,DT_NOCLIP,D3DCOLOR_XRGB(255,255,255)
		mov		eax,d3dpp.BackBufferHeight
		sub		eax,15*5
		invoke	SetRect,addr rc, 10,eax,0,0
		coinvoke	g_pFont,ID3DXFont,DrawTextA,g_pD3DXSprite,TEXT_("ID3DXFont now caches letters on one or more textures."),-1,addr rc,DT_NOCLIP,D3DCOLOR_XRGB(255,255,255)
		mov		eax,d3dpp.BackBufferHeight
		sub		eax,15*4
		invoke	SetRect,addr rc, 10,eax,0,0
		coinvoke	g_pFont,ID3DXFont,DrawTextA,g_pD3DXSprite,TEXT_("In order to sort by texture state changes on muliple"),-1,addr rc,DT_NOCLIP,D3DCOLOR_XRGB(255,255,255)
		mov		eax,d3dpp.BackBufferHeight
		sub		eax,15*3
		invoke	SetRect,addr rc, 10,eax,0,0
		coinvoke	g_pFont,ID3DXFont,DrawTextA,g_pD3DXSprite,TEXT_("draw calls to DrawTextA pass a ID3DXSprite and use"),-1,addr rc,DT_NOCLIP,D3DCOLOR_XRGB(255,255,255)
		mov		eax,d3dpp.BackBufferHeight
		sub		eax,15*2
		invoke	SetRect,addr rc, 10,eax,0,0
		coinvoke	g_pFont,ID3DXFont,DrawTextA,g_pD3DXSprite,TEXT_("flags ( D3DXSPRITE_ALPHABLEND or D3DXSPRITE_SORT_TEXTURE )"),-1,addr rc,DT_NOCLIP,D3DCOLOR_XRGB(255,255,255)
		coinvoke	g_pD3DXSprite,ID3DXSprite,End

		;// Demonstration 4:
		;// Draw 3D extruded text using a mesh created with D3DXFont
		invoke	RtlZeroMemory,addr mtrl,sizeof D3DMATERIAL9
		lea		edx,mtrl
		mov		eax,FLOAT_(0.0f)
   	      mov 		[edx].D3DMATERIAL9.Ambient.r,eax
   	      mov 		[edx].D3DMATERIAL9.Ambient.g,eax
   	      mov 		[edx].D3DMATERIAL9.Diffuse.r,eax
   	      mov 		[edx].D3DMATERIAL9.Diffuse.g,eax
		mov		eax,FLOAT_(1.0f)
   	      mov 		[edx].D3DMATERIAL9.Ambient.b,eax
   	      mov 		[edx].D3DMATERIAL9.Ambient.a,eax
  		mov 		[edx].D3DMATERIAL9.Diffuse.b,eax
   	      mov 		[edx].D3DMATERIAL9.Diffuse.a,eax

		coinvoke	g_pD3DDevice,IDirect3DDevice9,SetMaterial,addr mtrl
		coinvoke	g_pFontMesh,ID3DXMesh,DrawSubset,0

		invoke	FrameStats

		;// End the scene
		coinvoke	g_pD3DDevice,IDirect3DDevice9,EndScene
	.endif

	;// Present the backbuffer contents to the display
	coinvoke	g_pD3DDevice,IDirect3DDevice9,Present,NULL,NULL,NULL,NULL
	ret
RenderD3d	endp

;//-----------------------------------------------------------------------------
;// Name: MsgProc
;// Desc: The window's message handler
;//-----------------------------------------------------------------------------
WndProc	proc hwnd:DWORD,wMsg:DWORD,wParam:DWORD,lParam:DWORD
LOCAL	hdc:DWORD
LOCAL	lf:LOGFONT
LOCAL	cf:CHOOSEFONT

	.if	wMsg == WM_SIZE						; check if window size has changed
		.if  wParam == SIZE_RESTORED
				.if( m_bMaximized )
					mov		m_bMaximized,FALSE
				.endif
				.if( m_bMinimized)
					mov		m_bMinimized,FALSE
				.endif
				.if( !m_bMaximized && !m_bMinimized )
				invoke	InitGeometry,hWnd	; yes, reset geometry to new window size
				ret
				.endif
		.elseif wParam == SIZE_MINIMIZED
				mov		m_bMinimized,TRUE
				mov		m_bMaximized,FALSE
				ret
		.elseif wParam == SIZE_MAXIMIZED
				invoke	InitGeometry,hWnd	; yes, reset geometry to new window size
				mov		m_bMinimized,FALSE
				mov		m_bMaximized,TRUE
				ret
		.endif

	.elseif wMsg == WM_COMMAND
		.if wParam == ID_FONT

				invoke	GetDC,hwnd			; change font
				mov		hdc,eax
				invoke	GetDeviceCaps,hdc,LOGPIXELSY
				mov		ecx,Font_size
				mul 	      ecx
				mov 	      ecx,72
				xor 	      edx,edx
				div 	      ecx
				neg 	      eax
				mov		lf.lfHeight,eax
				invoke	ReleaseDC,hwnd,hdc
				mov		eax,Font_bold 
				mov		lf.lfWeight,eax 
				mov		eax,Font_italic
				mov		lf.lfItalic,al 
				invoke	lstrcpy,addr lf.lfFaceName,addr Font_name

				invoke	RtlZeroMemory,addr cf,sizeof CHOOSEFONT
				mov		cf.lStructSize,sizeof CHOOSEFONT
				mov		eax,hwnd
				mov		cf.hWndOwner,eax
				lea		eax,lf
				mov		cf.lpLogFont,eax
				mov		cf.Flags,CF_SCREENFONTS or CF_INITTOLOGFONTSTRUCT or CF_TTONLY
				invoke	ChooseFont,addr cf
				.if		eax>0
				mov		eax,cf.iPointSize
				mov 	      ecx,10
				xor 	      edx,edx
				div 	      ecx
				mov		Font_size,eax
				mov		eax,lf.lfWeight 
				mov		Font_bold,eax 
				xor		eax,eax
				mov		al,lf.lfItalic 
				mov		Font_italic,eax
				invoke	lstrcpy,addr Font_name,addr lf.lfFaceName
				invoke	InitFont		; make new font
				.endif
				ret
		.elseif wParam == ID_EXIT
				invoke	DestroyWindow,hwnd
				ret
		.endif

	.elseif	wMsg == WM_DESTROY
		invoke	PostQuitMessage,NULL
		return	0
	.else
		invoke	DefWindowProc,hwnd,wMsg,wParam,lParam
		ret
	.endif
WndProc	endp

;// WinMain
WinMain	proc hinst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD
LOCAL		wc:WNDCLASSEX
LOCAL		msg:MSG
LOCAL		rc:RECT
LOCAL		dx_WindowStyle:DWORD

	mov			wc.cbSize,sizeof WNDCLASSEX
	mov			wc.style,CS_CLASSDC
	mov			wc.lpfnWndProc,offset WndProc
	mov			wc.cbClsExtra,NULL
	mov			wc.cbWndExtra,NULL
	mov			eax,hInst
	mov			wc.hInstance,eax
	mov			wc.hbrBackground,NULL
	mov			wc.lpszMenuName,IDI_MENU
	mov			wc.lpszClassName,offset ClassName
	invoke		LoadIcon,hInst,SMILEY_ICON
	mov			wc.hIcon,eax
	mov			wc.hIconSm,eax
	invoke		LoadCursor,NULL,IDC_ARROW
	mov			wc.hCursor,eax
	invoke		RegisterClassEx,addr wc


	invoke		SetRect,addr rc,0,0,Window_width,Window_height        

;---------- [Center  window] ----------
	invoke		GetSystemMetrics,SM_CXSCREEN
	sub			eax,rc.right
	shr			eax,1
	mov			rc.left,eax
	invoke		GetSystemMetrics,SM_CYSCREEN
	sub			eax,rc.bottom
	shr			eax,1
	mov			rc.top,eax

	invoke		CreateWindowEx,0,addr ClassName,addr AppName,WS_OVERLAPPEDWINDOW,\
							rc.left,rc.top,rc.right,rc.bottom,NULL,NULL,hInst,NULL
	mov			hWnd,eax

	invoke		InitD3D,hWnd 
	cmp			eax,S_OK
	jnz			CloseD3d

	invoke		InitGeometry,hWnd
	cmp			eax,S_OK
	jnz			CloseD3d

	invoke		ShowWindow,hWnd,SW_SHOWNORMAL
	invoke		UpdateWindow,hWnd

	invoke		RtlZeroMemory,addr msg,sizeof msg

		.while (msg.message != WM_QUIT)
				invoke	PeekMessage, addr msg,NULL,0,0,PM_REMOVE
					.if eax != 0
						invoke	TranslateMessage,addr msg
						invoke	DispatchMessage,addr msg
					.else
						invoke	RenderD3d
					.endif
		.endw

CloseD3d:
	invoke		Cleanup 
	invoke		UnregisterClass,addr ClassName,wc.hInstance

	return 		msg.wParam
WinMain	endp

;// The application's entry point
;________________________________________________________________________________
start:
	invoke		GetModuleHandle,NULL
	mov			hInst,eax

	invoke		GetProcessHeap
	mov			Heap,eax

	invoke		WinMain,hInst,NULL,NULL,SW_SHOWDEFAULT
	invoke		ExitProcess,eax

;________________________________________________________________________________
end start
